//------------------------------------------------------------
//#define _DEBUG_
//------------------------------------------------------------
#include "RODOS1.h"
#include <iostream>
//------------------------------------------------------------
bool RODOS1_t::USB_GET_STATE(unsigned char &POWER_STATE, unsigned char &POWER_TIMER_OFF, unsigned char &POWER_TIMER_ON)
{   //    
    USB_BUF_CLEAR();
    bool RESULT=false;
    USB_BUFO[1]=0x7E;
    int i=3;   //   
    while (!RESULT & ((i--)>0))
    {
        if (USB_SET_FEATURE())
        {
            if (USB_GET_FEATURE())
            {
                if (USB_BUFI[1]==0x7E) { RESULT=true; POWER_STATE=USB_BUFI[2]; POWER_TIMER_OFF=USB_BUFI[3]; POWER_TIMER_ON=USB_BUFI[7]; }
                    else RESULT=false;
            }
        }
    }
#ifdef _DEBUG_
    if (!RESULT) std::cout << "   " << std::endl;
#endif
    return RESULT;
}
//------------------------------------------------------------
bool RODOS1_t::USB_RUN_OFF_ON(unsigned char POWER_TIMER_OFF, unsigned char POWER_TIMER_ON)
{   //  
    USB_BUF_CLEAR();
    bool RESULT=false;
    USB_BUFO[1]=0xE7;
    USB_BUFO[2]=0x00;
    USB_BUFO[3]=POWER_TIMER_OFF;    //	   100ms
    USB_BUFO[4]=POWER_TIMER_ON;     //	   10ms
    int i=3;   //   
    while (!RESULT & ((i--)>0))
    {
        if (USB_SET_FEATURE())
        {
            if (USB_GET_FEATURE())
            {
                if (USB_BUFI[1]==0xE7) { RESULT=(USB_BUFI[2]==0x00)&&(USB_BUFI[3]==POWER_TIMER_OFF)&&(USB_BUFI[4]==POWER_TIMER_ON); }
                    else RESULT=false;
            }
        }
    }
#ifdef _DEBUG_
    if (!RESULT) std::cout << " " << std::endl;
#endif
    return RESULT;
}
//------------------------------------------------------------
bool RODOS1_t::USB_SET_MANUAL(unsigned char POWER_RES, unsigned char POWER_RELEY)
{   //   
    USB_BUF_CLEAR();
    bool RESULT=false;
    USB_BUFO[1]=0x77;
    USB_BUFO[2]=0x04;
    USB_BUFO[3]=POWER_RES;
    USB_BUFO[4]=POWER_RELEY;
    int i=3;   //   
    while (!RESULT & ((i--)>0))
    {
        if (USB_SET_FEATURE())
        {
            if (USB_GET_FEATURE())
            {
                if (USB_BUFI[1]==0x77) { RESULT=(USB_BUFI[2]==0x04)&&(USB_BUFI[3]==POWER_RES)&&(USB_BUFI[4]==POWER_RELEY); }
                    else RESULT=false;
            }
        }
    }
#ifdef _DEBUG_
    if (!RESULT) std::cout << "  " << std::endl;
#endif
    return RESULT;
}
//------------------------------------------------------------
void RODOS1_t::RESET(void)
{
    if (USB_RUN_OFF_ON(POWER_OFF, POWER_ON)) std::cout << "RESET -> OK";
    else std::cout << "RESET -> ERROR";
}
//------------------------------------------------------------
void RODOS1_t::ON(void)
{
    if (USB_SET_MANUAL(0, 0))
        {
        usb_t::Sleep(10);
        if (USB_SET_MANUAL(1, 0))
            {
            usb_t::Sleep(100);
            if (USB_SET_MANUAL(1, 1))
                {
                if (USB_SET_MANUAL(0, 1)) std::cout << "ON -> OK";
                else std::cout << "ON -> ERROR";
                } else std::cout << "ON -> ERROR";
            } else std::cout << "ON -> ERROR";
        } else std::cout << "ON -> ERROR";
}
//------------------------------------------------------------
void RODOS1_t::OFF(void)
{
    if (USB_SET_MANUAL(1, 1))
    {
        usb_t::Sleep(10);
        if (USB_SET_MANUAL(1, 0))
        {
            usb_t::Sleep(10);
            if (USB_SET_MANUAL(0, 0)) std::cout << "OFF -> OK";
            else std::cout << "OFF -> ERROR";
        } else std::cout << "OFF -> ERROR";
    } else std::cout << "OFF -> ERROR";
}
//------------------------------------------------------------
